#  valid_ip  IP       undef   # 
sub valid_ip {
my @oct = grep { $_ >= 0 && $_ <= 255 && $_ !~ /^0\d{1,2}$/ } split /\./, shift;
return unless @oct == 4;
return join('.', @oct);
}

#         http://rassanov.ru/skripty/ip-adres.htm
# valid_ip_1  1    IP   undef   
sub valid_ip_1 {
4 == grep { $_ >= 0 && $_ <= 255 && $_ !~ /^0\d{1,2}$/ } split /\./, shift;
}


# valid_ip_2  IP       undef   
sub valid_ip_2 {
my @octets = split /\./, shift;
for ( my $i = 0; $i <= 3; $i++ ) {
     if ( defined $octets[$i] ) {
          return unless ($octets[$i] >= 0 && $octets[$i] <= 255 && $octets[$i] !~ /^0\d{1,2}$/);
     } else { $octets[$i] = 0; }
}
return join('.', @octets);
}


# valid_ip_3  true   IP   false  IP   ""  # 
sub valid_ip_3 {
    my @octets = split /\./, shift;
    my $osh = 0;
    for ( my $i = 0; $i <= 3; $i++ ) {
            if ( defined $octets[$i] ) {
                unless ($octets[$i] >= 0 && $octets[$i] <= 255 && $octets[$i] !~ /^0\d{1,2}$/) {
                        $octets[$i] = "<font color='#FF0000'> $octets[$i] </font>";
                        $osh++;
                }
            } else { $octets[$i] = 0; }
    }
    return('true', join('.', @octets)) unless ( $osh );
    return('false', join('.', @octets));
}


# valid_ip_4     0    IP
sub valid_ip_4 {
    my $ip = shift;
    return "  IP" unless ( $ip );

    return "   IP $ip" unless ( $ip =~ m/^[\d\.]+$/ );

    return " IP $ip -   " if ($ip =~ m/^\./);

    return " IP $ip -  " if ($ip =~ m/\.$/);

    #  
    return " - IP    4 " unless ( 3 == ($ip =~ tr/\./\./) );

    #   
    return "   IP -   " if ($ip =~ m/\.\./);

    #       
    foreach (split /\./, $ip) {
        return "   IP  $ip - $_" unless ($_ >= 0 && $_ < 256 && $_ !~ /^0\d{1,2}$/ );
    }
    return 0;
}
#      http://rassanov.ru   .  
